﻿Type=Service
Version=2.30
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim LWM As LWManager
	Dim LWE As LWEngine
	Dim Flyer As Bitmap 
	Dim Image, Resized As Bitmap
	Dim actualImageWidth As Int
End Sub
Sub Service_Create
	
End Sub

Sub Service_Start (StartingIntent As Intent)

	GetFlyerFromServer

	LWM.Initialize("LWM", True)

	If LWE.IsInitialized Then LWM_OffsetChanged(LWE)
End Sub

Sub Service_Destroy

End Sub
Sub LWM_OffsetChanged (Engine As LWEngine)

	If Flyer.IsInitialized = True AND Resized.IsInitialized = False Then
		Resized = ResizeImage(Flyer, Engine.FullWallpaperWidth, Engine.FullWallpaperHeight)
	End If
    
	If Resized.IsInitialized Then
        Engine.Rect.Left = -(Engine.FullWallpaperWidth - actualImageWidth) / 2
        Engine.Rect.Top = 0
        Engine.Rect.Right = Engine.Rect.Left + Engine.FullWallpaperWidth
        Engine.Rect.Bottom = Engine.FullWallpaperHeight
        Engine.Canvas.DrawBitmap(Resized, Null, Engine.Rect)
    End If
    
	Engine.RefreshAll
	
End Sub
Sub ResizeImage(original As Bitmap, TargetX As Int, TargetY As Int) As Bitmap
    Dim origRatio As Float = original.Width / original.Height
    Dim targetRatio As Float = TargetX / TargetY
    Dim scale As Float
   
   	If targetRatio > origRatio Then
        scale = TargetY / original.Height
    Else
        scale = TargetX / original.Width
    End If		
    
    
    Dim c As Canvas
    Dim b As Bitmap

	b.InitializeMutable(TargetX, TargetY)		
    c.Initialize2(b)
    'set the background
    c.DrawColor(Colors.Black)
    Dim r As Rect
    Dim w = original.Width * scale, h = original.Height * scale As Int
	actualImageWidth = w
    
	r.Initialize(TargetX / 2 - w / 2, TargetY / 2 - h / 2, TargetX / 2 + w / 2, TargetY / 2+ h / 2)

	c.DrawBitmap(original, Null, r)
    Return b
End Sub
Sub GetFlyerFromServer()
	Dim FlyerURL As String
	Dim DownloadJob As HttpJob
	
	FlyerURL = "http://flyercircle.net/electronic/fcDownload.php"
		
	DownloadJob.Initialize("DownloadJob",Me)
	DownloadJob.Download(FlyerURL)

	If LWE.IsInitialized Then LWM_OffsetChanged(LWE)
	
End Sub
Sub JobDone (Job As HttpJob)

	Dim Out As OutputStream

	Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	If Job.Success = True Then
		'Save the Flyer!
		Out = File.OpenOutput(File.DirInternal, "flyer.jpg", False)
		File.Copy2(Job.GetInputStream(), Out)
		Out.Close
			'Load and show the Image...
			Flyer = LoadBitmap(File.DirInternal,"flyer.jpg")
		
			
			If LWE.IsInitialized Then LWM_OffsetChanged(LWE)
	Else
		Log("Error: " & Job.ErrorMessage)
		ToastMessageShow("Error!",True)
	End If
	Job.Release
End Sub